//
//  ViewController.m
//  JSMessageExample
//
//  Created by Joshua Kehn on 10/27/14.
//  Copyright (c) 2014 KEHN. All rights reserved.
//

#import "ViewController.h"



@implementation ViewController

-(void)awakeFromNib{
     NSLog(@"jHHH");
   
}

- (void)setUpWebView {
    // First create a WKWebViewConfiguration object so we can add a controller
    // pointing back to this ViewController.
    WKWebViewConfiguration *configuration = [[WKWebViewConfiguration alloc]
                                             init];
    WKUserContentController *controller = [[WKUserContentController alloc]
                                           init];
    
    // Add a script handler for the "observe" call. This is added to every frame
    // in the document (window.webkit.messageHandlers.NAME).
    [controller addScriptMessageHandler:self name:@"observe"];
    configuration.userContentController = controller;
    
    // This is the URL to be loaded into the WKWebView.
    NSURL *jsbin = [[NSBundle mainBundle]URLForResource:@"AppControlTestWithWKWebView"  withExtension:@"html"];
    
    
     NSLog(@"jsbin %@",jsbin);
    // Initialize the WKWebView with the current frame and the configuration
    // setup above
    _weviewM = [[WKWebView alloc] initWithFrame:self.view.bounds
                                  configuration:configuration];
    
    
    // Load the jsbin URL into the WKWebView and then add it as a sub-view.
    [_weviewM loadRequest:[NSURLRequest requestWithURL:jsbin]];
    [self.container addSubview:_weviewM];
    
    _weviewM.wantsLayer = YES;
    
    
    
   
    /*  SET WKWEBVIEW CONSTRAINTS TO FOLLOW WINDOW SIZE  */
    
    NSLayoutConstraint *  constraintTop = [NSLayoutConstraint constraintWithItem:_weviewM  attribute:NSLayoutAttributeTop relatedBy:NSLayoutRelationEqual toItem:self.container attribute:NSLayoutAttributeTop multiplier:1.0f constant:19.f];
    
    
    NSLayoutConstraint *  constraintBottom = [NSLayoutConstraint constraintWithItem:_weviewM attribute:NSLayoutAttributeBottom relatedBy:NSLayoutRelationEqual toItem:self.container attribute:NSLayoutAttributeBottom multiplier:1.0f constant:0.f];
    
    NSLayoutConstraint *  constraintLeading= [NSLayoutConstraint constraintWithItem:_weviewM attribute: NSLayoutAttributeLeading relatedBy:NSLayoutRelationEqual toItem:self.container attribute:NSLayoutAttributeLeading multiplier:1.0f constant:0.f];
    
    NSLayoutConstraint *  constraintTrailing= [NSLayoutConstraint constraintWithItem:_weviewM attribute: NSLayoutAttributeTrailing relatedBy:NSLayoutRelationEqual toItem:self.container attribute:NSLayoutAttributeTrailing multiplier:1.0f constant:0.f];
    
    
    [self.container addConstraint:constraintTrailing];
    
    [self.container addConstraint:constraintLeading];
    [self.container addConstraint:constraintTop];
    [self.container addConstraint:constraintBottom];
    
    [_weviewM  setTranslatesAutoresizingMaskIntoConstraints: NO];
    
}

        
- (void)viewDidLoad {
    [super viewDidLoad];
 
    [self setUpWebView];
  
}

//-- Direct call From  App Action to Webpage
- (IBAction)runTimeline:(id)sender {
    
    NSString *exec_template = @"window.myhypedocument.startTimelineNamed('timeline1');$('#headline').html(\"received: %@\");";
    NSString *theMessage = @"Call from App = Run Timeline";
    
    NSString *exec = [NSString stringWithFormat:exec_template, theMessage];
    //NSString *exec = [NSString stringWithFormat:exec_template, version];
    [_weviewM evaluateJavaScript:exec completionHandler:nil];
    
    
   
}




//-- Calls From Webpage  to App

- (void)userContentController:(WKUserContentController *)userContentController
      didReceiveScriptMessage:(WKScriptMessage *)message {
 NSLog(@"Received event %@", message.body);
    // Check to make sure the name is correct
    if ([message.name isEqualToString:@"observe"]) {
        
       
 //--Open app window
        if ([message.body isEqualToString:@"OpenPrefs"] ) {
            [ _prefs makeKeyAndOrderFront:self];
            [self callBackToWebPage:message];
            return;
        }
        
        //--Open app window
        if ([message.body isEqualToString:@"OpenWin2"] ) {
            [ _window2 makeKeyAndOrderFront:self];
            [self callBackToWebPage:message];
            return;
        }
     
    }
    

    
}

//--execute the javascript from the callback
- (void)callBackToWebPage:(WKScriptMessage *)message
{
    NSString *theMessage = message.body;
    
    // Execute some JavaScript using the result
    NSString *exec_template = @"$('#headline').html(\"received: %@\");";
    NSString *exec = [NSString stringWithFormat:exec_template, theMessage];
    [_weviewM evaluateJavaScript:exec completionHandler:nil];
}


@end
